const canvas = document.getElementById("myCanvas");
const ctx = canvas.getContext("2d");

    let x,y,y1,n;
	let v;
	let dv;
	let av;
	let f;
	let r,r1;
	let t,l;
	let dt;
	let fl1,fl2,fl3;
	
    let d = { width: canvas.width, height: canvas.height };

function init() {
    	fl1=0;
		fl2=0;
		fl3=0;
		v=0;
		f=1;
		n=2;
		av=0.001;	
		dv=0;
		t=10;
		dt=5;
		r=4;
		r1=8;
		l=176;
		buffer = createBuffer(d.width, d.height);
        drawToBuffer();
}

function createBuffer(width, height) {
    const offscreenCanvas = document.createElement('canvas');
    offscreenCanvas.width = width;
    offscreenCanvas.height = height;
    return offscreenCanvas;
}

function drawToBuffer() {
    const g = buffer.getContext("2d");
	    g.fillStyle = "white";
        g.fillRect(0, 0, d.width, d.height);
		
		g.fillStyle = "black";
		g.fillRect(l-80+10,100-10,3*l+50,8);//気柱　横棒1
		g.fillRect(l-80+10,100+11*r1+2,3*l+50,8);//2
		g.fillRect(l-80+10,280-10,3*l+50,8);//3
		g.fillRect(l-80+10,280+11*r1+2,3*l+50,8);//4
		g.fillRect(l-80+l+r1+2,100-2,8,11*r1+4);//縦棒
		g.fillRect(l-80+3*l+r1+2,280-2,8,11*r1+4);
		g.fillRect(l-80+l+r1+10,140,30,8);//引き手
		g.fillRect(l-80+3*l+r1+10,320,30,8);
		
		
		g.strokeStyle="black";
		g.beginPath();
        g.moveTo(l-80+10,100+11*r1+20);
        g.lineTo(l-80+l+r1+2,100+11*r1+20);
        g.moveTo(l-80+l+r1+2,100+11*r1+47);
        g.lineTo(3*l-80+l+r1+2,100+11*r1+47 );
		g.moveTo(l-80+10,280+11*r1+20);
        g.lineTo(l-80+3*l+r1+2,280+11*r1+20);
		
        g.moveTo(l-80+10,100+11*r1+20);//矢印
        g.lineTo(l-80+10+10,100+11*r1+20-6 );
		g.moveTo(l-80+10,100+11*r1+20);//矢印
        g.lineTo(l-80+10+10,100+11*r1+20+6 );
		
		g.moveTo(l-80+l+r1+2,100+11*r1+20);//矢印
        g.lineTo(l-80+l+r1+2-10,100+11*r1+20-6 );
		g.moveTo(l-80+l+r1+2,100+11*r1+20);//矢印
        g.lineTo(l-80+l+r1+2-10,100+11*r1+20+6 );
		
		g.moveTo(l-80+l+r1+2,100+11*r1+47);//矢印
        g.lineTo(l-80+l+r1+2+10,100+11*r1+47-6 );
		g.moveTo(l-80+l+r1+2,100+11*r1+47);//矢印
        g.lineTo(l-80+l+r1+2+10,100+11*r1+47+6);
		
		g.moveTo(3*l-80+l+r1+2,100+11*r1+47);//矢印
        g.lineTo(3*l-80+l+r1+2-10,100+11*r1+47-6 );
		g.moveTo(3*l-80+l+r1+2,100+11*r1+47);//矢印
        g.lineTo(3*l-80+l+r1+2-10,100+11*r1+47+6);
		
		g.moveTo(l-80+10,280+11*r1+20);//矢印
        g.lineTo(l-80+10+10,280+11*r1+20-6 );
		g.moveTo(l-80+10,280+11*r1+20);//矢印
        g.lineTo(l-80+10+10,280+11*r1+20+6);
		
		g.moveTo(l-80+3*l+r1+2,280+11*r1+20);//矢印
        g.lineTo(l-80+3*l+r1+2-10,280+11*r1+20-6 );
		g.moveTo(l-80+3*l+r1+2,280+11*r1+20);//矢印
        g.lineTo(l-80+3*l+r1+2-10,280+11*r1+20+6);		
        g.stroke();
		
		g.fillStyle="black";
		g.fillText("L1",189,100+11*r1+20+15);
		g.fillText("L2",365,280+11*r1+20+15);
		g.fillText("HarfWaveLength",448,100+11*r1+47+15);
		g.fill();
			
            for (x=0;x<=4*l;x=x+2*r1){
			y=Math.sin(50*v)*100*Math.sin(x*2*Math.PI/(4*l))+x;	
	       
		    for (y1=0;y1<=5;y1=y1+1){
		    if(y>=l){
			g.fillStyle="red";
			g.beginPath();	
			g.arc(y-80+r1/2,280+y1*2*r1+r1/2,r1/2, 0, Math.PI * 2);////////?
			g.fill();
			}
		    }
			}
			
			for (x=0;x<=2*l;x=x+2*r1){
		    y=Math.sin(50*v)*100*Math.sin(x*2*Math.PI/(4*l))+x;	
	        for (y1=0;y1<=5;y1=y1+1){
		    if(y>=l){
			g.fillStyle="red";
			g.beginPath();	
			g.arc(y-80+r1/2,100+y1*2*r1+r1/2,r1/2, 0, Math.PI * 2);////////?
			g.fill();
			}
		    }
	        }

         if(fl2==1){
			for (x=0;x<=4*l;x=x+r){
			y=-Math.sin(50*v)*40*Math.sin(x*2*Math.PI/(4*l))+320+r/2;
			if(x>=l){
			g.fillStyle="blue";
			g.beginPath();	
			g.arc(x-80+r1/2,y+r1/2, r/2, 0, Math.PI * 2);
			g.fill();
			}
			}

			for (x=0;x<=2*l;x=x+r){
			y=-Math.sin(50*v)*40*Math.sin(x*2*Math.PI/(4*l))+140+r/2;
			if(x>=l){
			g.fillStyle="blue";
            g.beginPath();	
			g.arc(x-80+r1/2,y+r1/2,r/2, 0, Math.PI * 2);
			g.fill();			
			}
			}		
		}    			
	
    }


function move() {
    dv=fl1*av;
		v=v+dv;
		t=t+dt;
}

function start() {
    setInterval(function() {
        move();
        drawToBuffer();
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.drawImage(buffer, 0, 0);
    }, 20);
}

document.getElementById('dp').addEventListener('click', dp);
document.getElementById('ndp').addEventListener('click', ndp);
document.getElementById('run').addEventListener('click', run);
document.getElementById('stop').addEventListener('click', stop);
document.getElementById('sbs').addEventListener('click', sbs);
document.getElementById('reset').addEventListener('click', reset);

function dp() {//横波表示
        fl2=1;
}
function ndp() {//非表示
        fl2=0;
}
function run() {
        fl1=1;
}
function stop() {
        fl1=0;dv=0;
}
function sbs() {//コマ送り
        fl1=0;v=v+0.5;
}
function reset() {
       fl1=0;v=0;dv=0;y=0;
}


init();
start();